scala.tools.nsc.backend.icode.analysis.ReachingDefinitions

# ReachingDefinitionsAnalysis

#### class ReachingDefinitionsAnalysis extends DataFlowAnalysis[rdefLattice.type]

Source
  ReachingDefinitions.scala

Linear Supertypes
DataFlowAnalysis[rdefLattice.type], AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ReachingDefinitionsAnalysis
2. DataFlowAnalysis
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new ReachingDefinitionsAnalysis()

### Type Members

1. #### type P = Global.icodes.BasicBlock

   A type for program points.

   A type for program points.

   Definition Classes
     ReachingDefinitionsAnalysis → DataFlowAnalysis

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ReachingDefinitionsAnalysis to any2stringadd[ReachingDefinitionsAnalysis] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ReachingDefinitionsAnalysis, B)

   Implicit information
     This member is added by an implicit conversion from ReachingDefinitionsAnalysis to ArrowAssoc[ReachingDefinitionsAnalysis] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def backwardAnalysis(f: (P, Elem) ⇒ Elem): Unit

   Definition Classes
     DataFlowAnalysis

8. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

9. #### val drops: Map[Global.icodes.BasicBlock, Int]

10. #### def ensuring(cond: (ReachingDefinitionsAnalysis) ⇒ Boolean, msg: ⇒ Any): ReachingDefinitionsAnalysis

    Implicit information
      This member is added by an implicit conversion from ReachingDefinitionsAnalysis to Ensuring[ReachingDefinitionsAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: (ReachingDefinitionsAnalysis) ⇒ Boolean): ReachingDefinitionsAnalysis

    Implicit information
      This member is added by an implicit conversion from ReachingDefinitionsAnalysis to Ensuring[ReachingDefinitionsAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean, msg: ⇒ Any): ReachingDefinitionsAnalysis

    Implicit information
      This member is added by an implicit conversion from ReachingDefinitionsAnalysis to Ensuring[ReachingDefinitionsAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean): ReachingDefinitionsAnalysis

    Implicit information
      This member is added by an implicit conversion from ReachingDefinitionsAnalysis to Ensuring[ReachingDefinitionsAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

17. #### def findDefs(bb: Global.icodes.BasicBlock, idx: Int, m: Int): List[(Global.icodes.BasicBlock, Int)]

    Return the definitions that produced the topmost 'm' elements on the stack, and that reach the instruction at index 'idx' in basic block 'bb'.

18. #### def findDefs(bb: Global.icodes.BasicBlock, idx: Int, m: Int, depth: Int): List[(Global.icodes.BasicBlock, Int)]

    Return the instructions that produced the 'm' elements on the stack, below given 'depth'.

    Return the instructions that produced the 'm' elements on the stack, below given 'depth'. for instance, findefs(bb, idx, 1, 1) returns the instructions that might have produced the value found below the topmost element of the stack.

19. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ReachingDefinitionsAnalysis to StringFormat[ReachingDefinitionsAnalysis] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

20. #### def forwardAnalysis(f: (P, Elem) ⇒ Elem): Unit

    Implements forward dataflow analysis: the transfer function is applied when inputs to a Program point change, to obtain the new output value.

    Implements forward dataflow analysis: the transfer function is applied when inputs to a Program point change, to obtain the new output value.

    f

      the transfer function.

    Definition Classes
      DataFlowAnalysis

21. #### val gen: Map[Global.icodes.BasicBlock, ListSet[(Global.icodes.Local, Global.icodes.BasicBlock, Int)]]

22. #### def genAndKill(b: Global.icodes.BasicBlock): (ListSet[Definition], ListSet[Global.icodes.Local])

23. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

24. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

25. #### val in: Map[P, Elem]

    Definition Classes
      DataFlowAnalysis

26. #### def init(m: Global.icodes.IMethod): Unit

27. #### def init(f: ⇒ Unit): Unit

    Definition Classes
      DataFlowAnalysis

28. #### def interpret(b: Global.icodes.BasicBlock, idx: Int, in: Elem): Elem

    Return the reaching definitions corresponding to the point after idx.

29. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

30. #### var iterations: Int

    the number of times we iterated before reaching a fixpoint.

    the number of times we iterated before reaching a fixpoint.

    Definition Classes
      DataFlowAnalysis

31. #### val kill: Map[Global.icodes.BasicBlock, ListSet[Global.icodes.Local]]

32. #### val lattice: rdefLattice.type

    Definition Classes
      ReachingDefinitionsAnalysis → DataFlowAnalysis

33. #### var method: Global.icodes.IMethod

34. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

35. #### final def notify(): Unit

    Definition Classes
      AnyRef

36. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

37. #### val out: Map[P, Elem]

    Definition Classes
      DataFlowAnalysis

38. #### val outStack: Map[Global.icodes.BasicBlock, collection.immutable.List[ListSet[(Global.icodes.BasicBlock, Int)]]]

39. #### def run(): Unit

    Definition Classes
      ReachingDefinitionsAnalysis → DataFlowAnalysis

40. #### var stat: Boolean

    collect statistics?

    collect statistics?

    Definition Classes
      DataFlowAnalysis

41. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

42. #### def toString(): String

    Definition Classes
      ReachingDefinitionsAnalysis → AnyRef → Any

43. #### def updateReachingDefinition(b: Global.icodes.BasicBlock, idx: Int, rd: ListSet[Definition]): ListSet[Definition]

44. #### val visited: HashSet[P]

    Definition Classes
      DataFlowAnalysis

45. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

47. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

48. #### val worklist: Set[P]

    Definition Classes
      DataFlowAnalysis

49. #### def →[B](y: B): (ReachingDefinitionsAnalysis, B)

    Implicit information
      This member is added by an implicit conversion from ReachingDefinitionsAnalysis to ArrowAssoc[ReachingDefinitionsAnalysis] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from DataFlowAnalysis[rdefLattice.type]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ReachingDefinitionsAnalysis to any2stringadd[ReachingDefinitionsAnalysis]

### Inherited by implicit conversion StringFormat from ReachingDefinitionsAnalysis to StringFormat[ReachingDefinitionsAnalysis]

### Inherited by implicit conversion Ensuring from ReachingDefinitionsAnalysis to Ensuring[ReachingDefinitionsAnalysis]

### Inherited by implicit conversion ArrowAssoc from ReachingDefinitionsAnalysis to ArrowAssoc[ReachingDefinitionsAnalysis]

### Ungrouped